--
-- Created by: shalmuy at 10/26/15 Time: 10:55 AM
--

TTP_Utils = TTP_Utils or {}

--- BUGGY! It's best to write things youself...
--- returns the contents of "t" in a beautiful, LUA-style way:
--- delays the function call to a particular number of seconds.
-- @function table2string
-- @t table to convert
TTP_Utils.table2string = function(t)
    local print_r_cache = {}
    local str = ''
    local function add2str(s) str = str .. s .. '\n' end

    local function sub_print_r(t, indent)
        if (print_r_cache[tostring(t)]) then
            add2str(indent .. "*" .. tostring(t))
        else
            print_r_cache[tostring(t)] = true
            if (type(t) == "table") then
                for pos, val in pairs(t) do
                    if (type(val) == "table") then
                        add2str(indent .. "[" .. tostring(pos) .. "] => " .. tostring(t) .. " {")
                        sub_print_r(val, indent .. string.rep(" ", string.len(pos) + 8))
                        add2str(indent .. string.rep(" ", string.len(pos) + 6) .. "}")
                    elseif (type(val) == "string") then
                        add2str(indent .. "[" .. tostring(pos) .. '] => "' .. val .. '"')
                    else
                        add2str(indent .. "[" .. tostring(pos) .. "] => " .. tostring(val))
                    end
                end
            else
                add2str(indent .. tostring(t))
            end
        end
    end

    if (type(t) == "table") then
        add2str(tostring(t) .. " {")
        sub_print_r(t, "  ")
        add2str("}")
    else
        sub_print_r(t, "  ")
    end
    --    return str
    return str:match "^%s*(.-)%s*$"
end

TTP_Utils.print_r = function(t) print(TTP_Utils.table2string(t)) end
